import * as GraphQL from "graphql";
import { DenormalizationResult, Variables, ResolveType } from "./types";
import { NormMap } from "./norm-map";
/**
 * Creates a graphql response by denormalizing.
 * @param query The graphql query document
 * @param variables The graphql query variables
 * @param normMap The map of normalized objects
 * @param resolveType Function get get typeName from an object
 */
export declare function denormalize(query: GraphQL.DocumentNode, variables: Variables | undefined, normMap: NormMap, resolveType?: ResolveType): DenormalizationResult;
