export interface NormMap {
    readonly [key: string]: NormObj;
}
export declare type NormKey = string;
export declare type NormFieldValue = NormKey | string | boolean | number | null | NormFieldValueArray;
export interface NormFieldValueArray extends ReadonlyArray<NormFieldValue> {
}
export interface NormObj {
    readonly [field: string]: null | NormFieldValue;
}
/**
 * An optimized function to merge two maps of normalized objects (as returned from normalize)
 * @param normMap The first normalized map
 * @param newNormMap The second normalized map
 */
export declare function merge(normMap: NormMap, newNormMap: NormMap): NormMap;
