/**
 * An optimized function to merge two maps of normalized objects (as returned from normalize)
 * @param normMap The first normalized map
 * @param newNormMap The second normalized map
 */
export function merge(normMap, newNormMap) {
    const updatedNormMap = Object.keys(newNormMap).reduce((stateSoFar, current) => {
        const newNormObj = Object.assign({}, (normMap[current] || {}), newNormMap[current]);
        stateSoFar[current] = newNormObj;
        return stateSoFar;
    }, {});
    return Object.assign({}, normMap, updatedNormMap);
}
//# sourceMappingURL=norm-map.js.map