import * as GraphQL from "graphql";
import { GetObjectId, RootFields, Variables, ResolveType } from "./types";
import { NormMap } from "./norm-map";
/**
 * Normalizes a graphql response.
 * @param query The graphql query document
 * @param variables The graphql query variables
 * @param response The graphql response
 * @param getObjectId Function to get normalized map key from an object
 * @param resolveType Function get get typeName from an object
 */
export declare function normalize(query: GraphQL.DocumentNode, variables: Variables | undefined, data: RootFields, getObjectId?: GetObjectId, resolveType?: ResolveType): NormMap;
